// define function-like macro "CK()" to check run-time conditions
// Author:  Terence Kelly <tpkelly@acm.org>

#ifndef CK_H_INCLUDED
#define CK_H_INCLUDED

#define CK_S2(s) #s
#define CK_S1(s) CK_S2(s)
#define CK_COORDS __FILE__ ":" CK_S1(__LINE__) ":  "
#define CK(e, f, ...)                                              \
  do {                                                             \
    if (!(e)) {                                                    \
      const char *CK_es = #e;  /* avoid trouble with "%" in #e */  \
      fprintf(stderr, CK_COORDS "check '%s' failed:  " f "\n",     \
                                        CK_es, __VA_ARGS__);       \
      exit(EXIT_FAILURE);                                          \
    }                                                              \
  } while (0)

#endif

