#!/usr/bin/gawk -f

# Print lookup table for  F(x) = M + R*x mod P

# For "Drill Bits" column in July/August 2023 issue of
# ACM _Queue_ magazine:  https://queue.acm.org/DrillBits

BEGIN {
    LINT = 1;   # so gawk will warn about errors

    P = 7;  # prime number
    printf("\n");
    for (M = 0; M < P; M++) {
        for (R = 0; R < P; R++) {
            printf("M=%d,R=%d  ", M, R);
            for (x = 1; x < P; x++) {
                F = (M + R*x) % P;
                printf("    x=%d,F=%d", x, F);
            }
            printf("\n");
        }
        printf("\n");
    }
}

