#!/usr/bin/csh -f

# C-Shell script to compile and run modulo_bias program

# For "Drill Bits" column in July/August 2023 issue of
# ACM _Queue_ magazine:  https://queue.acm.org/DrillBits

if (-e warnflags) then
    set wf = `gawk '/^[cx]/{print $2}' warnflags`
else
    echo 'using bare-bones warning flags'
    set wf = '-Wall -Wextra'
endif

# CFLAGS analogue.  Manually disables a handful of warnings.
set cf = "-std=c11 $wf -Wno-c90-c99-compat"

set b = modulo_bias

echo ''
echo 'compile twice: once for max warnings, once for debuggability'
echo '' ; rm -f $b ; gcc $cf -O3 -o $b $b.c ; echo ''
echo '' ; rm -f $b ; gcc $cf -Og -o $b $b.c ; echo ''

echo 'run with no argument (default seed)' ; echo ''
./modulo_bias
echo ''
echo 'run with seed' ; echo ''
./modulo_bias 47
echo ''

